var nativeCallback = {};
window.nativeCallback = nativeCallback;
var nativeApi = (function () {
    function initReady(callback) {
        platform = "Android";
        window.androidAPI = createNativeApiObject(); //window.WebStormApi;
        if (typeof callback == "function") {
            callback();
        }
    }

    function createNativeApiObject() {
        var api = {}
        var methodProxy = function (apiObject) {
            for (var key in apiObject) {
                api[key] = (function (key) {
                    return function (param) {
                        return param ? apiObject[key](param) : apiObject[key]()
                    }
                })(key)
            }
        }

        //methodProxy(window.WebStormApi)
        methodProxy(window.LatexApi)
        //methodProxy(window.HomeworkApi)

        return window._api = api
    }

    function distribute(methodName, param, callBack) {
        var result;

        if (param == null) {
            result = androidAPI[methodName]()
        } else if (typeof param == "object") {
            param = JSON.stringify(param);
            result = androidAPI[methodName](param)
        } else {
            result = androidAPI[methodName](param)
        }
        if (callBack) {
            try {
                result = JSON.parse(result);
            } catch (e) {
            }
            callBack(result);
        }

    }

    function register(callbackName, callback) {
        nativeCallback[callbackName] = callback;
    }

    return {
        registerCallback: function (callbackName, callback) {
            register(callbackName, callback);
        },
        ready: function (callback) {
            initReady(callback);
        },
        /*getEnvironment: function (callback) {
            distribute("getEnvironment", null, callback);
        },
        getToken: function (callback) {
            distribute("getToken", null, callback);
        },
        setTitle: function (param, callback) {
            if (!param.buttons || !param.buttons.length) {
                param.buttons = []
                if (param.button) {
                    param.buttons.push(param.button)
                }

                if (param.other_button) {
                    param.buttons.push(param.other_button)
                }
            }

            distribute("setTitle", param, callback);
        },*/
        getLatexCallback: function(latex) {
            distribute("getLatexCallback", latex);
        },
        callKeyboard: function (param, callback) {
            distribute("callKeyboard", param, callback);
        },
        closeKeyboard: function (param, callback) {
            distribute("closeKeyBoard", param, callback);
        },
        onPositionChange: function () {
            distribute("onPositionChange");
        }
    }
})();

window.nativeApi = nativeApi
