window.androidCallback = {};
var rrtCommon = {
    data: {},
    setData: function (key, value) {
        rrtCommon.data[key] = value;
    },
    getData: function (key) {
        return rrtCommon.data[key];
    },
    getOffset: function (obj) {  //获取任意元素的offsetLeft/offsetTop值
        var offsetT = 0
        while (obj != window.document.body && obj != null) {
            offsetT += obj.offsetTop
            obj = obj.offsetParent
        }
        return offsetT
    },
    registerKeyboardCallback: function () {
        nativeApi.registerCallback("keyboardOpen", function () {
            //判断当前输入方式
            console.info("打开键盘回调")
            var input = document.activeElement;
            if (input === document.body) {
                var index = window.calculatorList.indexOf(window.currentDemo);
                input = $($(".dcg-container")[index]).find(".dcg-selected")[0];
                //input = $('.dcg-selected')[index >= 0 ? index : 0];
            }
            var a = rrtCommon.getOffset(input) + 100;
            var $window = $(window);
            /*console.info("input offset=>"+a);
             console.info("$window height=>"+$window.height());
             console.info("$window offset=>"+($window.scrollTop() + $window.height()));*/
            if (a < $window.scrollTop() || a > ($window.scrollTop() + $window.height())) {
                $('body').scrollTop(a - $window.height()); // ==>self
            }
        });
    },

    registerCloseKeyBoardCallback: function () {
        nativeApi.registerCallback("onKeyBoardClose", function (arg) {
            rrtCommon.setData("keyboard", false);
        });
    },

    callKeyboard: function (param) {
        nativeApi.callKeyboard(param, function () {
            rrtCommon.setData("keyboard", true);
        });
    },

    getCursorPositionTop: function () {
        var top = 0;
        var calIndex = window.calculatorList.indexOf(window.currentDemo);
        if (calIndex != -1) {
            if ($($('.dcg-container')[calIndex]).find('.dcg-selected').length > 0) {
                top = $($('.dcg-container')[calIndex]).find('.dcg-selected').offset().top;
            } else {
                top = 0;
            }
        } else {
            top = 0
        }
        return top;
    },

    handleCalInputClick: function (e) {
        rrtCommon.setData("canUserKeyboard", true);
        $("input, textarea").blur();
        window.Desmos.$(".dcg-container").not($(e.target).parents(".dcg-container")).find('.mathquill-editable').mathquill('blur');
        var box = $(e.target).parents(".dcg-container");
        // var index = $(".dcg-container").indexOf(box[0]);
        var index = $.inArray(box[0], $(".dcg-container"));
        window.currentDemo = window.calculatorList[index];

        setTimeout(function () {
            var top = rrtCommon.getCursorPositionTop();
            if ($(e.target).parents(".dcg-expressionitem")[0] != rrtCommon.getData("currentInput")) {
                rrtCommon.setData("currentInput", $(e.target).parents(".dcg-expressionitem")[0]);
                rrtCommon.callKeyboard({type: "0", pointY: top});
            } else {
                if (rrtCommon.getData("keyboard")) {
                    nativeApi.onPositionChange();
                } else {
                    rrtCommon.callKeyboard({type: "0", pointY: top});
                }
            }
        },50);

        getResult();
    },

    handleCalInputBlur: function (callback) {
        rrtCommon.setData("currentInput", null);
        rrtCommon.setData("canUserKeyboard", false);
        window.currentDemo = null;
        $("input, textarea").blur();
        window.Desmos && window.Desmos.$(".dcg-container").find('.mathquill-editable').mathquill('blur');
        nativeApi.closeKeyboard(2);

        if(callback) {
            callback()
        }
    },

    handleInputClick: function () {
        rrtCommon.setData("currentInput", null);
        rrtCommon.setData("canUserKeyboard", false);
        window.currentDemo = null;
        window.Desmos.$(".dcg-container").find('.mathquill-editable').mathquill('blur');
    },

    openCalculator: function () {
        if (rrtCommon.getData("canUserKeyboard")) {
            var top = rrtCommon.getCursorPositionTop();
            rrtCommon.callKeyboard({type: "1", pointY: top});
        } else {
            alert("当前不能使用符号键盘！");
        }
    },
}
window.rrtCommon = rrtCommon;
